#include "HTTPGet.h"

HTTPGetWindow::HTTPGetWindow( BRect frame, char *name ) : BWindow( frame, name, B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE )
{
	BRect rect;
	float strwidth;
	
	Lock();
	
	rect.Set( XGUTTER, YGUTTER, WINWIDTH - XGUTTER, YGUTTER + FONTSIZE + 4 );
	url = new BTextControl( rect, "URL", "URL:", 0, 0 );
	AddChild( url );
	strwidth = url->StringWidth( "URL:" );
	url->SetDivider( strwidth + 5.0 );
	rect = url->Frame();
	
	rect.OffsetBy( 0, INNERGUTTER + rect.Height() );
	get = new BButton( rect, "Get", "Get", new BMessage( HTGT_GetButton ) );
	AddChild( get );
	rect = get->Frame();
	
	ResizeTo( WINWIDTH, rect.bottom + YGUTTER );
	Unlock();
}

void HTTPGetWindow::MessageReceived( BMessage *msg )
{
	NetSocket *sock;
	
	switch( msg->what )
	{
		case HTGT_GetButton:
			strcpy( urlcp, url->Text() );
			RunSavePanel( getfilename( urlcp ) );
			break;
		default:
			BWindow::MessageReceived( msg );
			break;
	}
}

bool HTTPGetWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
}

void HTTPGetWindow::SaveRequested( record_ref dir, const char *filename )
{
	BDirectory bdir( dir );
	BFile bfile;
	BRect rect;
	
	if( bdir.Create( filename, &bfile ) == B_NO_ERROR )
	{
		rect.Set( 0, 0, 200, 10 );
		((HTTPGetApplication *)be_app)->status->AddStatusBar( new URLStatus( urlcp, rect, bfile.Record()->Ref() ) );
	}
	else
	{
		BAlert *alert;
		char errorstr[256];
		
		sprintf( errorstr, "Cannot create file:\n%s", filename );
		alert = new BAlert( "HTTPGet", errorstr, "OK" );
		alert->Go();
	}
}

char *HTTPGetWindow::getfilename( char *url )
{
	char *slash = 0;
	int index;
	
	for( index = 0; url[index]; index++ )
	{
		if( url[index] == '/' )
			slash = &url[index];
	}
	slash++;
	return( slash );
}
